import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class AddInputParameter extends TextBox implements CommandListener 
{
    PCalc     calc;
    List      parent;
    Program   prog;
   
    AddInputParameter(PCalc calc, List parent, Program prog) { 
        super("Add parameter", "", 16, TextField.ANY);
        this.calc = calc;
        this.parent = parent;
        this.prog = prog;
       
        setCommandListener(this);
        addCommand(PCalc.ADD_CMD);       
        addCommand(PCalc.CANCEL_CMD);       
        Display.getDisplay(calc).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d) 
    {
        if (c == PCalc.ADD_CMD) { 
            String name = getString();
            if (name.length() == 0) { 
                calc.showError("Name should not be empty", this);
                return;
            }
            int i = prog.addInputParam(name);
            if (i < 0) { 
                calc.showError("Parameter already exists", this);
                return;
            } 
            parent.append(name, null);
        }
        Display.getDisplay(calc).setCurrent(parent);            
    }
}



