import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class AddProcedure extends TextBox implements CommandListener 
{
    PCalc     calc;
    List      parent;
    Procedure proc;
   
    AddProcedure(PCalc calc, List parent, Procedure proc) { 
        super("Procedure name", "", 16, TextField.ANY);
        this.calc = calc;
        this.parent = parent;
        this.proc = proc;
       
        setCommandListener(this);
        addCommand(PCalc.ADD_CMD);       
        addCommand(PCalc.CANCEL_CMD);       
        Display.getDisplay(calc).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d) 
    {
        if (c == PCalc.ADD_CMD) { 
            String name = getString();
            if (name.length() == 0) { 
                calc.showError("Name should not be empty", this);
                return;
            }
            int i = proc.addSubproc(name);
            if (i < 0) { 
                calc.showError("Procedure already exists", this);
                return;
            }
            parent.insert(i, name, null);
            parent.setSelectedIndex(i, true);
        }
        Display.getDisplay(calc).setCurrent(parent);            
    }
}



