import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class BackTrace extends List implements CommandListener
{
    PCalc          calc;
    Debugger       debugger;
    VirtualMachine vm;

    static private String formatAddress(int x) { 
        String s = "00" + x;
        return s.substring(s.length()-3);
    }

    BackTrace(PCalc calc, Debugger debugger, VirtualMachine vm) {
        super("Back trace", IMPLICIT);
        this.calc = calc;
        this.debugger = debugger;
        this.vm = vm;

        for (int i = vm.cSp; --i >= 0;) { 
            append(formatAddress(i) + ": " + vm.callStack[i].proc.name, null);
        }
        setCommandListener(this);
        addCommand(PCalc.OK_CMD);
        Display.getDisplay(calc).setCurrent(this);
    }
    
    public void commandAction(Command c, Displayable d) 
    {
        if (c == PCalc.OK_CMD) { 
            debugger.goBack();
        } else { 
            int i = vm.cSp - getSelectedIndex() - 1;
            new InspectVariables(calc, this, vm.callStack[i]);
        }
    }
}
           


