import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class ChooseFunction extends List implements CommandListener 
{
    PCalc       calc;
    List        parent;
    Procedure   proc;
    int         listIndex;
    int         pc;
    boolean     update;
    
    ChooseFunction(PCalc calc, List parent, Procedure proc, int listIndex, int pc, boolean update) { 
        super("Choose function", List.IMPLICIT);
        this.calc = calc;
        this.parent = parent;
        this.proc = proc;
        this.listIndex = listIndex;
        this.pc = pc;
        this.update = update;
        
        Procedure scope = proc;
        do { 
            for (int i = 0; i < scope.subprocs.length; i++) { 
                String name;
                if (scope == proc || scope.subprocs[i] == proc) { 
                    name = scope.subprocs[i].name;
                } else { 
                    name = scope.name + '.' + scope.subprocs[i].name;
                }
                append(name, null);
            }
        } while((scope = scope.top) != null);

        setCommandListener(this);
        addCommand(PCalc.BACK_CMD);
        Display.getDisplay(calc).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d) 
    {
        if (c == PCalc.BACK_CMD) { 
            parent.setSelectedIndex(listIndex, true);
            Display.getDisplay(calc).setCurrent(parent);
            return;
        }
        int i = getSelectedIndex();
        
        Procedure scope = proc;
        while (i >= scope.subprocs.length) { 
            i -= scope.subprocs.length;
            scope = scope.top;
        }     

        if (update) { 
            String cmd = parent.getString(listIndex);
            parent.set(listIndex, cmd.substring(0, cmd.lastIndexOf(' ') + 1) +  scope.subprocs[i].name, null);
            parent.setSelectedIndex(listIndex, true);
        } else { 
            proc.addInstruction(pc, VirtualMachine.CALL);
            parent.insert(listIndex, "  call " +  scope.subprocs[i].name, null);
            parent.setSelectedIndex(listIndex+1, true);
        }
        proc.code[pc+1] = (byte)scope.level;
        proc.code[pc+2] = (byte)i;
        Display.getDisplay(calc).setCurrent(parent);
    }
}



