import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class ChooseInputVariable extends List implements CommandListener 
{
    PCalc       calc;
    List        parent;
    Procedure   proc;
    int         listIndex;
    int         pc;
    boolean     update;
   
    ChooseInputVariable(PCalc calc, List parent, Procedure proc, int listIndex, int pc, boolean update) { 
        super("Input parameter", List.IMPLICIT);
        this.calc = calc;
        this.parent = parent;
        this.proc = proc;
        this.listIndex = listIndex;
        this.pc = pc;
        this.update = update;
       
        for (int i = 0; i < proc.prog.inputParamNames.length; i++) { 
            append(proc.prog.inputParamNames[i], null);
        }

        setCommandListener(this);
        addCommand(PCalc.NEW_CMD);       
        Display.getDisplay(calc).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d) 
    {
        int i = getSelectedIndex();
        if (c == PCalc.NEW_CMD) { 
            new NewInputParameter(calc, parent, proc, listIndex, pc, update);
        } else { 
            if (update) { 
                String cmd = parent.getString(listIndex);
                parent.set(listIndex, cmd.substring(0, cmd.lastIndexOf(' ') + 1) + proc.prog.inputParamNames[i], null);
                parent.setSelectedIndex(listIndex, true);
            } else { 
                proc.addInstruction(pc, VirtualMachine.INPUT);
                parent.insert(listIndex, "  input " + proc.prog.inputParamNames[i], null);
                parent.setSelectedIndex(listIndex+1, true);
            }
            proc.code[pc+1] = (byte)i;
            Display.getDisplay(calc).setCurrent(parent);
        }
    }
}



