import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class ChooseVariable extends List implements CommandListener 
{
    PCalc       calc;
    List        parent;
    Procedure   proc;
    int         listIndex;
    int         pc;
    int         cop;
    boolean     update;
    
    ChooseVariable(PCalc calc, List parent, Procedure proc, int listIndex, int pc, int cop, boolean update) { 
        super("Choose variable", List.IMPLICIT);
        this.calc = calc;
        this.parent = parent;
        this.proc = proc;
        this.listIndex = listIndex;
        this.cop = cop;
        this.pc = pc;
        this.update = update;
        
        Procedure scope = proc;
        do { 
            for (int i = 0; i < scope.vars.length; i++) { 
                String name;
                if (scope == proc) { 
                    name = scope.vars[i];
                } else { 
                    name = scope.name + '.' + scope.vars[i];
                }
                append(name, null);
            }
        } while((scope = scope.top) != null);

        setCommandListener(this); 
        if (cop == VirtualMachine.STORE && proc.vars.length < Procedure.MAX_VARIABLES) 
        {     
            addCommand(PCalc.NEW_CMD);
        } else { 
            addCommand(PCalc.BACK_CMD);
        }
       
        Display.getDisplay(calc).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d) 
    {
        int i = getSelectedIndex();
        if (c == PCalc.BACK_CMD) { 
            parent.setSelectedIndex(listIndex, true);
            Display.getDisplay(calc).setCurrent(parent);
        } else if (c == PCalc.NEW_CMD) { 
            new NewVariable(calc, parent, proc, listIndex, pc, update);
        } else { 
            Procedure scope = proc;
            while (i >= scope.vars.length) { 
                i -= scope.vars.length;
                scope = scope.top;
            }     
            if (update) { 
                String cmd = parent.getString(listIndex);
                parent.set(listIndex, cmd.substring(0, cmd.lastIndexOf(' ') + 1) + scope.vars[i], null);
                parent.setSelectedIndex(listIndex, true);
            } else { 
                proc.addInstruction(pc, cop);
                parent.insert(listIndex, (cop == VirtualMachine.LOAD ? "  load "  : "  store ") +  scope.vars[i], null);
                parent.setSelectedIndex(listIndex+1, true);
            }
            proc.code[pc+1] = (byte)scope.level;
            proc.code[pc+2] = (byte)i;
            Display.getDisplay(calc).setCurrent(parent);
        }
    }
}



