import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class EditProgram extends Form implements CommandListener
{
    PCalc       calc;
    List        parent;
    Program     prog;
    int         listIndex;
    TextField   nameField;
    TextField   descField;

    EditProgram(PCalc calc, List parent, int listIndex, Program prog) { 
        super("Edit program");
        this.calc = calc;
        this.parent = parent;
        this.listIndex = listIndex;
        this.prog = prog;
        
        nameField = new TextField("Name", prog.name, 32, TextField.ANY);
        descField = new TextField("Description", prog.description, 256, TextField.ANY);
        append(nameField);
        append(descField);

        setCommandListener(this);
        addCommand(PCalc.EDIT_CODE_CMD);
        addCommand(PCalc.RUN_CMD);
        addCommand(PCalc.DEBUG_CMD);
        addCommand(PCalc.PARAMETERS_CMD);
        addCommand(PCalc.SAVE_CMD);
        Display.getDisplay(calc).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d) 
    {
        if (c == PCalc.SAVE_CMD) { 
            prog.name = nameField.getString();
            if (prog.name.length() == 0) { 
                calc.showError("Name should not be empty", this);
                return;
            }
            prog.description = descField.getString();
            calc.saveProgram(prog);
            parent.set(listIndex, prog.name, null);
            Display.getDisplay(calc).setCurrent(parent);
        } else if (c == PCalc.EDIT_CODE_CMD) {
            new EditProcedure(calc, this, prog.main);
        } else if (c == PCalc.RUN_CMD) {
            new Launcher(calc, this, prog, false);
        } else if (c == PCalc.DEBUG_CMD) {
            new Launcher(calc, this, prog, true);
        } else if (c == PCalc.PARAMETERS_CMD) {
            new ParameterList(calc, this, prog);
        }
    }
}       


