import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class InputLiteral extends TextBox implements CommandListener {
    PCalc       calc;
    List        parent;
    Procedure   proc;
    int         listIndex;
    int         pc;
    boolean     update;

    InputLiteral(PCalc calc, List parent, Procedure proc, int listIndex, int pc, boolean update) { 
        super("Input literal", update ? VirtualMachine.printNumber(VirtualMachine.unpackFloat(proc.code, pc+1)) : "", VirtualMachine.MAX_NUMBER_LEN, TextField.ANY);
        this.calc = calc;
        this.parent = parent;
        this.proc = proc;
        this.listIndex = listIndex;
        this.pc = pc;
        this.update = update;
      
        setCommandListener(this);
        addCommand(PCalc.SAVE_CMD);
        addCommand(PCalc.CANCEL_CMD);
       
        Display.getDisplay(calc).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d) 
    {
        if (c == PCalc.SAVE_CMD) { 
            String value = getString();
            try { 
                Float fp = VirtualMachine.inputNumber(value);
                if (update) { 
                    String cmd = parent.getString(listIndex);
                    int l = cmd.indexOf(':');
                    if (l >= 0) { 
                        cmd = cmd.substring(0, l+1);
                    } else { 
                        cmd = "  ";
                    }
                    parent.set(listIndex, cmd + value, null);
                    parent.setSelectedIndex(listIndex, true);
                } else { 
                    proc.addInstruction(pc, VirtualMachine.LITERAL);
                    parent.insert(listIndex, "  " + value, null);
                    parent.setSelectedIndex(listIndex+1, true);
                }
                VirtualMachine.packFloat(proc.code, pc+1, fp);                    
            } catch (NumberFormatException x) { 
                calc.showError("Invalid constant", this);
                return;
            }
        } else { 
            parent.setSelectedIndex(listIndex, true);
        }
        Display.getDisplay(calc).setCurrent(parent);
    }
}


 
