import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class InspectStack extends List implements CommandListener
{
    PCalc          calc;
    Debugger       debugger;

    static private String formatAddress(int x) { 
        String s = "00" + x;
        return s.substring(s.length()-3);
    }

    InspectStack(PCalc calc, Debugger debugger, VirtualMachine vm) {
        super("Stack", IMPLICIT);
        this.calc = calc;
        this.debugger = debugger;

        for (int i = vm.oSp; --i >= 0;) { 
            append(formatAddress(i) + ": " + VirtualMachine.printNumber(vm.opdStack[i]), null);
        }
        setCommandListener(this);
        addCommand(PCalc.OK_CMD);
        removeCommand(List.SELECT_COMMAND);
        Display.getDisplay(calc).setCurrent(this);
    }
    
    public void commandAction(Command c, Displayable d) 
    {
        if (c == PCalc.OK_CMD) { 
            debugger.goBack();
        }
    }
}
           


