import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class InspectVariables extends Form implements CommandListener
{
    PCalc       calc;
    Displayable parent;

    InspectVariables(PCalc calc, Displayable parent, Frame fp) {
        super("Variables");
        this.calc = calc;
        this.parent = parent;

        Procedure proc = fp.proc;
        int level = proc.level;
        do { 
            for (int i = 0; i < proc.vars.length; i++) { 
                append(new StringItem(proc.vars[i], VirtualMachine.printNumber(fp.display[level].vars[i])));
            }
            proc = proc.top;
        } while (--level >= 0); 

        setCommandListener(this);
        addCommand(PCalc.OK_CMD);
        Display.getDisplay(calc).setCurrent(this);
     }
    
    public void commandAction(Command c, Displayable d) 
    {
        if (parent instanceof Debugger) { 
            ((Debugger)parent).goBack();
        } else { 
            Display.getDisplay(calc).setCurrent(parent);
        }
    }
}
           


