import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class Launcher extends Form implements CommandListener
{
    PCalc       calc;
    Displayable parent;
    Program     prog;
    TextField[] inputParams;

    Launcher(PCalc calc, Displayable parent, Program prog, boolean debug) {
        super(debug ? "Debug program" : "Start program");
        this.calc = calc;
        this.parent = parent;
        this.prog = prog;

        inputParams = new TextField[prog.inputParams.length];
        for (int i = 0; i < inputParams.length; i++) { 
            inputParams[i] = new TextField(prog.inputParamNames[i], VirtualMachine.printNumber(prog.inputParams[i]), 
                                           VirtualMachine.MAX_NUMBER_LEN, TextField.ANY);
            append(inputParams[i]);
        }

        setCommandListener(this);
        if (debug) { 
            addCommand(PCalc.STEP_CMD);
        } else { 
            addCommand(PCalc.START_CMD);           
        }
        addCommand(PCalc.CANCEL_CMD);
        Display.getDisplay(calc).setCurrent(this);
    }

    
    public void commandAction(Command c, Displayable d) 
    {
        if (c == PCalc.CANCEL_CMD) { 
            Display.getDisplay(calc).setCurrent(parent);
        } else { 
            for (int i = 0; i < inputParams.length; i++) { 
                try {
                    prog.inputParams[i] = VirtualMachine.inputNumber(inputParams[i].getString());
                } catch (NumberFormatException x) { 
                    calc.showError("Invalid value for parameter " + prog.inputParamNames[i], this);
                    return;
                }
            }
            calc.saveProgram(prog);
            if (c == PCalc.STEP_CMD) { 
                new Debugger(calc, this, prog);
            } else { 
                new Monitor(calc, this, new VirtualMachine(prog));
            }
        }
    }
}
           


