import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class Monitor extends Form implements CommandListener
{
    PCalc            calc;
    Launcher         parent;
    VirtualMachine   vm;
    StringItem       item;
    TimerThread      timer;
    ExecutorThread   executor;
    long             startTime;
    volatile boolean terminated;
    
    static final long SECOND = 1000;
    
    class TimerThread extends Thread { 
        public void run() { 
            try { 
                while (!terminated) { 
                    sleep(SECOND);
                    long now = System.currentTimeMillis();
                    item.setText(Integer.toString((int)((now - startTime)/1000)));
                }
            } catch (InterruptedException x) {}
        }
    }

    class ExecutorThread extends Thread {
        public void run(){ 
            try { 
                vm.run();
            } catch (ArithmeticException x) {
                terminated = true;
                calc.showError("Arithmetic exception", new Debugger(calc, parent, vm, false));
                return;
            } catch (StackEmptyException x) {
                terminated = true;
                calc.showError("Stack empty", new Debugger(calc, parent, vm, false));
                return;
            } catch (StackOverflowException x) {
                terminated = true;
                calc.showError("Stack overflow", new Debugger(calc, parent, vm, false));
                return;
            }
            if (terminated) { 
                new Debugger(calc, parent, vm, true);
            } else { 
                long now = System.currentTimeMillis();
                new ShowResults(calc, parent, vm, (int)(now-startTime));
            }
        }
    }
    Monitor(PCalc calc, Launcher parent, VirtualMachine vm) {
        super("Running...");
        this.calc = calc;
        this.parent = parent;
        this.vm = vm;
        item = new StringItem("Elapsed time", "0");
        append(item);
        setCommandListener(this);
        addCommand(PCalc.STOP_CMD);
        Display.getDisplay(calc).setCurrent(this);

        startTime = System.currentTimeMillis();
        timer = new TimerThread();
        executor = new ExecutorThread();
        timer.start();
        executor.start();
    }

    
    public void commandAction(Command c, Displayable d) 
    {
        if (c == PCalc.STOP_CMD) { 
            vm.running = false;
            terminated = true;
        }
    }
}
           


