import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class MoveLabel extends List implements CommandListener 
{
    PCalc       calc;
    List        parent;
    Procedure   proc;
    int         listIndex;
    int         pc;
   
    MoveLabel(PCalc calc, List parent, Procedure proc, int listIndex, int pc) { 
        super("Move label", List.IMPLICIT);
        this.calc = calc;
        this.parent = parent;
        this.proc = proc;
        this.listIndex = listIndex;
        this.pc = pc;
       
        String[] insns = VirtualMachine.printInstructions(proc);
        for (int i = 0; i < insns.length; i++) { 
            append(insns[i], null);
        }        
        setSelectedIndex(listIndex, true);
        
        setCommandListener(this);
        addCommand(PCalc.BACK_CMD);
        Display.getDisplay(calc).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d) 
    {
        if (c != PCalc.BACK_CMD) { 
            int i = getSelectedIndex();
            if (i == size()-1) { 
                return;
            }
            String cmd = getString(i);
            if (cmd.indexOf(':') >= 0) { 
                calc.showError("Instruction already has label", this);
                return;
            }
            String prevCmd = parent.getString(listIndex);
            int col = prevCmd.indexOf(':');
            String label = prevCmd.substring(0, col+1);
            parent.set(listIndex, "  " + prevCmd.substring(col+1), null);
            parent.set(i, label + cmd.substring(2), null);
            VirtualMachine.moveLabel(proc.code, pc, VirtualMachine.getPcForInstruction(proc.code, i));
        }
        parent.setSelectedIndex(listIndex, true);
        Display.getDisplay(calc).setCurrent(parent);
    }
}



