import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class NewInputParameter extends TextBox implements CommandListener 
{
    PCalc       calc;
    List        parent;
    Procedure   proc;
    int         listIndex;
    int         pc;
    boolean     update;
   
    NewInputParameter(PCalc calc, List parent, Procedure proc, int listIndex, int pc, boolean update) { 
        super("New parameter", "", 16, TextField.ANY);
        this.calc = calc;
        this.parent = parent;
        this.proc = proc;
        this.listIndex = listIndex;
        this.pc = pc;
        this.update = update;

        setCommandListener(this);
        addCommand(PCalc.ADD_CMD);       
        addCommand(PCalc.CANCEL_CMD);       
        Display.getDisplay(calc).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d) 
    {
        if (c == PCalc.ADD_CMD) { 
            String name = getString();
            if (name.length() == 0) { 
                calc.showError("Name should not be empty", this);
                return;
            }               
            int i = proc.prog.addInputParam(name);
            if (i < 0) { 
                calc.showError("Parameter already exists", this);
                return;
            }
            if (update) { 
                String cmd = parent.getString(listIndex);
                parent.set(listIndex, cmd.substring(0, cmd.lastIndexOf(' ') + 1) + name, null);
                parent.setSelectedIndex(listIndex, true);
            } else { 
                proc.addInstruction(pc, VirtualMachine.INPUT);
                parent.insert(listIndex, "  input " + name, null);
                parent.setSelectedIndex(listIndex+1, true);
            }
            proc.code[pc+1] = (byte)i;
        } else { 
            parent.setSelectedIndex(listIndex, true);
        }
        Display.getDisplay(calc).setCurrent(parent);            
    }
}



