import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class ParameterList extends List implements CommandListener 
{
    PCalc       calc;
    Displayable parent;
    Program     prog;

    ParameterList(PCalc calc, Displayable parent, Program prog) 
    { 
        super("Input parameters", List.IMPLICIT);
        this.calc = calc;
        this.parent = parent;
        this.prog = prog;
        
        for (int i = 0; i < prog.inputParams.length; i++) { 
            append(prog.inputParamNames[i], null);            
        }

        setCommandListener(this);
        addCommand(PCalc.BACK_CMD);
        addCommand(PCalc.ADD_CMD);
        addCommand(PCalc.DELETE_CMD);
        addCommand(PCalc.EDIT_CMD);
        Display.getDisplay(calc).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d) 
    {
        if (c == PCalc.BACK_CMD) { 
            Display.getDisplay(calc).setCurrent(parent);
        } else if (c == PCalc.DELETE_CMD) { 
            int i = getSelectedIndex();
            if (!prog.removeInputParam(i)) { 
                calc.showError("Parameter is used", this);
                return;
            }
            delete(i);
        }  else if (c == PCalc.ADD_CMD) { 
            if (prog.inputParams.length < Program.MAX_PARAMETERS) { 
                new AddInputParameter(calc, this, prog);
            } else { 
                calc.showError("Limit for number of parameters is reached", this);
            }
        } else { 
            new SetInputParameter(calc, this, prog, getSelectedIndex());
        }
    }
}



