import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class ProcedureList extends List implements CommandListener 
{
    PCalc       calc;
    Displayable parent;
    Procedure   proc;
    
    ProcedureList(PCalc calc, Displayable parent, Procedure proc) { 
        super(proc.name + " procedures", List.IMPLICIT);
        this.calc = calc;
        this.parent = parent;
        this.proc = proc;
        
        Procedure scope = proc;
        while (true) { 
            for (int i = 0; i < scope.subprocs.length; i++) { 
                String name;
                if (scope == proc || proc == scope.subprocs[i]) { 
                    name = scope.subprocs[i].name;
                } else { 
                    name = scope.name + '.' + scope.subprocs[i].name;
                }
                append(name, null);
            }
            if (scope.top == null) { 
                append(scope.name, null);
                break;
            }
            scope = scope.top;
        }

        setCommandListener(this);
        addCommand(PCalc.ADD_CMD);
        addCommand(PCalc.EDIT_CMD);
        addCommand(PCalc.RENAME_CMD);
        addCommand(PCalc.DELETE_CMD);
        addCommand(PCalc.DONE_CMD);
        Display.getDisplay(calc).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d) 
    {
        int i = getSelectedIndex();
        if (c == PCalc.DONE_CMD) { 
            Display.getDisplay(calc).setCurrent(parent);           
        } else if (c == PCalc.ADD_CMD) { 
            if (proc.subprocs.length < Procedure.MAX_SUBPROCS) { 
                new AddProcedure(calc, this, proc);
            } else {
                calc.showError("Limit for maximal number of subprocedures is reached", this);
            }
        } else if (c == PCalc.RENAME_CMD) { 
            if (i >= proc.subprocs.length) { 
                calc.showError("Only self subprocedures can be renamed", this);
            } else { 
                new RenameProcedure(calc, this, proc, i);
            }
        } else if (c == PCalc.DELETE_CMD) { 
            if (i >= proc.subprocs.length) { 
                calc.showError("Only self subprocedures can be removed", this);
            } else if (proc.subprocs[i].subprocs.length != 0) { 
                calc.showError("Procedure with subprocedures can not be removed", this);
            } else if (!proc.removeSubproc(i)) { 
                calc.showError("Procedure is used", this);
            } else {
                delete(i);
            }
        } else {         
            Procedure scope = proc;
            while (i >= scope.subprocs.length) { 
                i -= scope.subprocs.length;
                if (scope.top == null) { 
                    new EditProcedure(calc, parent, scope);
                    return;
                } 
                scope = scope.top;
            }     
            new EditProcedure(calc, parent, scope.subprocs[i]);
        }
    }
}



