import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class RenameVariable extends TextBox implements CommandListener 
{
    PCalc        calc;
    VariableList parent;
    Procedure    proc;
    int          index;

    RenameVariable(PCalc calc, VariableList parent, Procedure proc, int index) { 
        super("Rename variable", proc.vars[index], 16, TextField.ANY);
        this.calc = calc;
        this.parent = parent;
        this.proc = proc;
        this.index = index;
       
        setCommandListener(this);
        addCommand(PCalc.OK_CMD);       
        addCommand(PCalc.CANCEL_CMD);       
        Display.getDisplay(calc).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d) 
    {
        if (c == PCalc.OK_CMD) { 
            String name = getString();
            if (!proc.vars[index].equals(name)) { 
                if (name.length() == 0) { 
                    calc.showError("Name should not be empty", this);
                    return;
                } else if (proc.findVariable(name) >= 0) {
                    calc.showError("Variable already exists", this);
                    return;
                }
                proc.vars[index] = name;
                parent.set(index, name, null);
                parent.parent.redraw();
            }
        }
        Display.getDisplay(calc).setCurrent(parent);            
    }
}



