import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class SelectCommand extends List implements CommandListener 
{
    PCalc       calc;
    List        parent;
    Procedure   proc;
    int         listIndex;
    int         pc;
    int         from;

    SelectCommand(PCalc calc, List parent, Procedure proc, int listIndex, int pc, int from, int till) { 
        super("Select command", List.IMPLICIT);
        this.calc = calc;
        this.parent = parent;
        this.proc = proc;
        this.listIndex = listIndex;
        this.pc = pc;
        this.from = from;

        for (int i = from; i <= till; i++) { 
            append(i == VirtualMachine.LITERAL ? "literal" : VirtualMachine.insnMnemonic[i], null);
        }

        setCommandListener(this);
        addCommand(PCalc.BACK_CMD);
        Display.getDisplay(calc).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d) 
    {
        if (c == PCalc.BACK_CMD) {
            parent.setSelectedIndex(listIndex, true);
            Display.getDisplay(calc).setCurrent(parent);
        } else { 
            int i = from + getSelectedIndex();
            switch (i) { 
            case VirtualMachine.LITERAL:
                new InputLiteral(calc, parent, proc, listIndex, pc, false);
                break;           
            case VirtualMachine.STORE:
            case VirtualMachine.LOAD:
                new ChooseVariable(calc, parent, proc, listIndex, pc, i, false);
                break;
            case VirtualMachine.INPUT:
                new ChooseInputVariable(calc, parent, proc, listIndex, pc, false);
                break;
            case VirtualMachine.IF:
            case VirtualMachine.GOTO:
                new SetLabel(calc, parent, proc, listIndex, pc, i, false);
                break;
            case VirtualMachine.CALL:
                new ChooseFunction(calc, parent, proc, listIndex, pc, false);
                break;
            default:
                proc.addInstruction(pc, i);
                parent.insert(listIndex, "  " + VirtualMachine.insnMnemonic[i], null);
                parent.setSelectedIndex(listIndex+1, true);
                Display.getDisplay(calc).setCurrent(parent);
            }
        }
    }
}


        
 
