import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class SelectCommandGroup extends List implements CommandListener 
{
    PCalc       calc;
    List        parent;
    Procedure   proc;
    int         listIndex;
    int         pc;
    
    static final String[] commandGroups = { "Load/Store", "Literal", "Operators", "Functions", "Control Flow", "All" };

    SelectCommandGroup(PCalc calc, List parent, Procedure proc, int listIndex, int pc) { 
        super("Command group", List.IMPLICIT, commandGroups, null);
        this.calc = calc;
        this.parent = parent;
        this.proc = proc;
        this.listIndex = listIndex;
        this.pc = pc;
       
        setCommandListener(this);
        addCommand(PCalc.BACK_CMD);
        Display.getDisplay(calc).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d) 
    {
        if (c == PCalc.BACK_CMD) {
            parent.setSelectedIndex(listIndex, true);
            Display.getDisplay(calc).setCurrent(parent);
        } else { 
            switch (getSelectedIndex()) { 
            case 0:
                new SelectCommand(calc, parent, proc, listIndex, pc, VirtualMachine.LOAD, VirtualMachine.LOAD_PI);
                break;
            case 1:
                new InputLiteral(calc, parent, proc, listIndex, pc, false);
                break;
            case 2:
                new SelectCommand(calc, parent, proc, listIndex, pc, VirtualMachine.NEG, VirtualMachine.LE);
                break;
            case 3:
                new SelectCommand(calc, parent, proc, listIndex, pc, VirtualMachine.ABS, VirtualMachine.TAN);
                break;
            case 4:
                new SelectCommand(calc, parent, proc, listIndex, pc, VirtualMachine.IF, VirtualMachine.GOTO);
                break;
            default:
                new SelectCommand(calc, parent, proc, listIndex, pc, VirtualMachine.LITERAL, VirtualMachine.GOTO);
                break;
            }
        }
    }
}


        
 
