import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class SetInputParameter extends Form implements CommandListener
{
    PCalc       calc;
    List        parent;
    Program     prog;
    int         index;
    TextField   name;
    TextField   value;

    SetInputParameter(PCalc calc, List parent, Program prog, int index) {
        super("Set value");
        this.calc = calc;
        this.parent = parent;
        this.prog = prog;
        this.index = index;

        name = new TextField("Parameter name", prog.inputParamNames[index], 12, TextField.ANY);
        value = new TextField("Parameter value", VirtualMachine.printNumber(prog.inputParams[index]), 
                              VirtualMachine.MAX_NUMBER_LEN, TextField.ANY);
        append(name);
        append(value);

        setCommandListener(this);
        addCommand(PCalc.OK_CMD);
        addCommand(PCalc.CANCEL_CMD);
        Display.getDisplay(calc).setCurrent(this);
    }

    
    public void commandAction(Command c, Displayable d) 
    {
        if (c == PCalc.CANCEL_CMD) { 
            Display.getDisplay(calc).setCurrent(parent);
        } else { 
            String newName = name.getString();
            if (newName.length() == 0) { 
                calc.showError("Name should not be empty", this);
            } else if (!newName.equals(prog.inputParamNames[index]) && prog.findInputParam(newName) >= 0) { 
                calc.showError("Parameter already exists", this);
            } else { 
                try {
                    prog.inputParams[index] = VirtualMachine.inputNumber(value.getString());
                    prog.inputParamNames[index] = newName;
                    parent.set(index, newName, null);
                    Display.getDisplay(calc).setCurrent(parent);                    
                } catch (NumberFormatException x) { 
                    calc.showError("Invalid parameter value", this);
                }
            }
        }
    }
}
           


