import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class SetLabel extends List implements CommandListener 
{
    PCalc       calc;
    List        parent;
    Procedure   proc;
    int         listIndex;
    int         pc;
    int         cop;
    boolean     update;
   
    SetLabel(PCalc calc, List parent, Procedure proc, int listIndex, int pc, int cop, boolean update) 
    { 
        super("Set label", List.IMPLICIT);
        this.calc = calc;
        this.parent = parent;
        this.proc = proc;
        this.listIndex = listIndex;
        this.pc = pc;
        this.cop = cop;
        this.update = update;
       
        String[] insns = VirtualMachine.printInstructions(proc);
        for (int i = 0; i < insns.length; i++) { 
            append(insns[i], null);
        }        
        int addr = update ? Converter.unpackInt(proc.code, pc+1) : pc;
        setSelectedIndex(VirtualMachine.getInstructionForPc(proc.code, addr), true);
        
        setCommandListener(this);
        addCommand(PCalc.BACK_CMD);
        Display.getDisplay(calc).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d) 
    {
        if (c == PCalc.BACK_CMD) { 
            parent.setSelectedIndex(listIndex, true);
        } else { 
            int i = getSelectedIndex();
            if (i == size()-1) { 
                return;
            }
            String cmd = parent.getString(i);
            int col = cmd.indexOf(':');
            String label;
            if (col >= 0) { 
                label = cmd.substring(0, col+1);
            } else { 
                label = Integer.toString(++proc.nLabels) + ':';
                parent.set(i, label + cmd.substring(2), null);
            }
            if (update) { 
                cmd = parent.getString(listIndex);
                parent.set(listIndex, cmd.substring(0, cmd.lastIndexOf(' ') + 1) + label, null);
                parent.setSelectedIndex(listIndex, true);
            } else { 
                proc.addInstruction(pc, cop);
                parent.insert(listIndex, (cop == VirtualMachine.IF ? "  if " : "  goto ") + label, null);
                parent.setSelectedIndex(listIndex+1, true);
            } 
            if (i >= listIndex) { 
                i += 1;
            }
            int target = VirtualMachine.getPcForInstruction(proc.code, i);                
            Converter.packInt(proc.code, pc+1, target);
        }
        Display.getDisplay(calc).setCurrent(parent);
    }
}



