import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class VariableList extends List implements CommandListener 
{
    PCalc         calc;
    EditProcedure parent;
    Procedure     proc;
    
    VariableList(PCalc calc, EditProcedure parent, Procedure proc) { 
        super(proc.name + " variables", List.IMPLICIT);
        this.calc = calc;
        this.parent = parent;
        this.proc = proc;
        
        Procedure scope = proc;
        do { 
            for (int i = 0; i < scope.vars.length; i++) { 
                String name;
                if (scope == proc) { 
                    name = scope.vars[i];
                } else { 
                    name = scope.name + '.' + scope.vars[i];
                }
                append(name, null);
            }
        } while ((scope = scope.top) != null);

        setCommandListener(this);
        addCommand(PCalc.OK_CMD);
        addCommand(PCalc.RENAME_CMD);
        addCommand(PCalc.DELETE_CMD);
        removeCommand(List.SELECT_COMMAND);
        Display.getDisplay(calc).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d) 
    {
        int i = getSelectedIndex();
        if (c == PCalc.OK_CMD) { 
            Display.getDisplay(calc).setCurrent(parent);
        } else if (c == PCalc.RENAME_CMD) { 
            if (i >= proc.vars.length) { 
                calc.showError("Only self variable can be renamed", this);
            } else { 
                new RenameVariable(calc, this, proc, i);
            }
        } else if (c == PCalc.DELETE_CMD) { 
            if (i >= proc.vars.length) { 
                calc.showError("Only self variable can be removed", this);
            } else if (!proc.removeVariable(i)) { 
                calc.showError("Variable is used", this);
            } else { 
                delete(i);
            }
        }
    }
}



